<?php
add_action('widgets_init', 'wellpress_mag_classic');

function wellpress_mag_classic()
{
	register_widget('wellpress_mag_classic');
}

class wellpress_mag_classic extends WP_Widget {
	
	public function __construct() {
		$widget_ops = array('classname' => 'wellpress_mag_classic', 'description' => esc_html__('!!Posts block for homepage only!!','everify'));
       	parent::__construct(false, esc_html__('Themnific: Mag (Classic)','everify'),$widget_ops);  
	}
	
	function widget($args, $instance)
	{
		extract($args);
		
		$layout = isset( $instance['layout'] ) ? esc_attr( $instance['layout'] ) : '';
		$post_type = 'all';
		$categories = isset( $instance['categories'] ) ? esc_attr( $instance['categories'] ) : '';
		$posts = isset( $instance['posts'] ) ? esc_attr( $instance['posts'] ) : '';
		$offset_posts = isset( $instance['offset_posts'] ) ? esc_attr( $instance['offset_posts'] ) : '';
		$excerpt_dis = ! empty( $instance['excerpt_dis'] ) ? '1' : '0';
		$center_text = ! empty( $instance['center_text'] ) ? '0' : '1';
		$title_size = isset( $instance['title_size'] ) ? esc_attr( $instance['title_size'] ) : '';
		$tags_selection = isset( $instance['tags_selection'] ) ? esc_attr( $instance['tags_selection'] ) : '';
		
		echo wp_kses_post($before_widget);
		?>
		
		<?php
		$post_types = get_post_types();
		unset($post_types['page'], $post_types['attachment'], $post_types['revision'], $post_types['nav_menu_item']);
		
		if($post_type == 'all') {
			$post_type_array = $post_types;
		} else {
			$post_type_array = $post_type;
		}
		?>
        
        <div class="widget_block">
            
			<?php
			$recent_posts = new WP_Query(array(
				'showposts' => $posts,
				'ignore_sticky_posts' => 1,
				'cat' => $categories,
				'offset' => esc_attr($offset_posts),
				'post_status' => 'publish',
				'tag' => esc_attr($tags_selection)
			));
			
			?>
            <div class="tmnf_mag tmnf_columns_wrap">
            
                <?php  while($recent_posts->have_posts()): $recent_posts->the_post(); ?>
            
                <div class="tmnf_column <?php echo esc_attr($layout); ?> <?php if( 'on' == $instance[ 'excerpt_dis' ] ){ echo ' tmnf_excerpt_enabled ';} else {echo ' tmnf_excerpt_disabled ';} ?>
            	<?php if( '1' == $instance[ 'center_text' ] ) : echo ' tmnf_center_text ';endif; ?>
            	<?php echo esc_attr($title_size); ?>">
    
                    <?php if(has_post_format('aside')){} else {
                        get_template_part('/post-types/post-mag-classic');
                    }?>
                    
                </div>
    
                <?php endwhile;wp_reset_postdata(); ?>
                
			</div>
            
			<div class="clearfix"></div>
            
        </div>
		
		<?php
		echo wp_kses_post($after_widget);
	}
	
	function update($new_instance, $old_instance)
	{
		$instance = $old_instance;
		
		$instance['layout'] = $new_instance['layout'];
		$instance['post_type'] = 'all';
		$instance['categories'] = $new_instance['categories'];
		$instance['posts'] = sanitize_text_field($new_instance['posts']);
		$instance['offset_posts'] = sanitize_text_field($new_instance['offset_posts']);
		$instance['excerpt_dis']        = ! empty( $new_instance['excerpt_dis'] ) ? 1 : 0;
		$instance['center_text']        = ! empty( $new_instance['center_text'] ) ? 1 : 0;
		$instance['title_size'] = $new_instance['title_size'];
		$instance['tags_selection'] = sanitize_text_field($new_instance['tags_selection']);
		
		return $instance;
	}

	function form($instance)
	{
		$defaults = array('post_type' => 'all', 'categories' => 'all', 'posts' => 4, 'layout' => 'tmnf_column_3','offset_posts' => '','tags_selection' => '');
		$modern_style        = isset( $instance['modern_style'] ) ? (bool) $instance['modern_style'] : false;
		$instance = wp_parse_args((array) $instance, $defaults); ?>

		
		<p>
			<label for="<?php echo esc_attr($this->get_field_id('categories')); ?>"><?php esc_html_e('Filter by Category','everify'); ?></label> 
			<select id="<?php echo esc_attr($this->get_field_id('categories')); ?>" name="<?php echo esc_attr($this->get_field_name('categories')); ?>" class="widefat categories" style="width:100%;">
				<option value='all' <?php if ('all' == $instance['categories']) echo 'selected="selected"'; ?>>all categories</option>
				<?php $categories = get_categories('hide_empty=0&depth=1&type=post'); ?>
				<?php foreach($categories as $category) { ?>
				<option value='<?php echo esc_attr($category->term_id); ?>' <?php if ($category->term_id == $instance['categories']) echo 'selected="selected"'; ?>><?php echo esc_attr($category->cat_name); ?></option>
				<?php } ?>
			</select>
		</p>
        
        <p>
			<label for="<?php echo esc_attr($this->get_field_id('layout')); ?>"><?php esc_html_e('Layout','everify'); ?>: </label>
			<select id="<?php echo esc_attr($this->get_field_id('layout')); ?>" name="<?php echo esc_attr($this->get_field_name('layout')); ?>" class="widefat">
				<?php 
				$layout_options = apply_filters('em_widget_order_ddm', array(
					'tmnf_column_3' => esc_html__('4 Columns','everify'),
					'tmnf_column_4' => esc_html__('3 Columns','everify'),
					'tmnf_column_6' => esc_html__('2 Columns','everify'),
					'tmnf_column_12' => esc_html__('1 Columns','everify'),
				)); 
				?>
				<?php foreach( $layout_options as $key => $value) : ?>   
	 			<option value='<?php echo esc_attr($key); ?>' <?php echo esc_attr($key == $instance['layout']) ? "selected='selected'" : ''; ?>>
	 				<?php echo esc_html($value); ?>
	 			</option>
				<?php endforeach; ?>
			</select>
        </p>
		
		<p>
			<label for="<?php echo esc_attr($this->get_field_id('posts')); ?>"><?php esc_html_e('Number of posts','everify'); ?></label>
			<input class="widefat" style="width: 40px;" id="<?php echo esc_attr($this->get_field_id('posts')); ?>" name="<?php echo esc_attr($this->get_field_name('posts')); ?>" value="<?php echo esc_attr($instance['posts']); ?>" />
		</p>
		
		<p>
			<label for="<?php echo esc_attr($this->get_field_id('offset_posts')); ?>"><?php esc_html_e('Offset posts','everify'); ?></label>
			<input class="widefat" style="width: 40px;" id="<?php echo esc_attr($this->get_field_id('offset_posts')); ?>" name="<?php echo esc_attr($this->get_field_name('offset_posts')); ?>" value="<?php echo esc_attr($instance['offset_posts']); ?>" />
		</p>
        
        <p>
            <input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id( 'excerpt_dis' ); ?>" name="<?php echo $this->get_field_name( 'excerpt_dis' ); ?>"<?php checked( $excerpt_dis ); ?> />
			<label for="<?php echo $this->get_field_id( 'excerpt_dis' ); ?>"><?php  esc_html_e('Disable Excerpt','everify');  ?></label>
        </p>
        
        <p>
            <input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id( 'center_text' ); ?>" name="<?php echo $this->get_field_name( 'center_text' ); ?>"<?php checked( $center_text ); ?> />
			<label for="<?php echo $this->get_field_id( 'center_text' ); ?>"><?php  esc_html_e('Center Text','everify');  ?></label>
        </p>
        
        <p>
			<label for="<?php echo esc_attr($this->get_field_id('title_size')); ?>"><?php esc_html_e('Titles Size','everify'); ?>: </label>
			<select id="<?php echo esc_attr($this->get_field_id('title_size')); ?>" name="<?php echo esc_attr($this->get_field_name('title_size')); ?>" class="widefat">
				<?php 
				$layout_options = apply_filters('em_widget_order_ddm', array(
					'tmnf_titles_are_medium' => esc_html__('Medium Titles','everify'),
					'tmnf_titles_are_large' => esc_html__('Large Titles','everify'),
					'tmnf_titles_are_small' => esc_html__('Small Titles','everify'),
				)); 
				?>
				<?php foreach( $layout_options as $key => $value) : ?>   
	 			<option value='<?php echo esc_attr($key); ?>' <?php echo esc_attr($key == $instance['title_size']) ? "selected='selected'" : ''; ?>>
	 				<?php echo esc_html($value); ?>
	 			</option>
				<?php endforeach; ?>
			</select>
        </p>
		
		<p>
			<label for="<?php echo esc_attr($this->get_field_id('tags_selection')); ?>"><?php esc_html_e('Filter by a tag. Write tags separated by commas. (Does not work with the combination of offset posts selection.)','everify'); ?></label>
			<input class="widefat" id="<?php echo esc_attr($this->get_field_id('tags_selection')); ?>" name="<?php echo esc_attr($this->get_field_name('tags_selection')); ?>" value="<?php echo esc_attr($instance['tags_selection']); ?>" />
		</p>


	<?php }
}
?>