<?php
add_action('widgets_init', 'wellpress_slider_widget');

function wellpress_slider_widget()
{
	register_widget('wellpress_slider_widget');
}

class wellpress_slider_widget extends WP_Widget {
	
	public function __construct() {
		$widget_ops = array('classname' => 'wellpress_slider_widget', 'description' => esc_html__('!!Posts block for Elementor only!!','cp-addons'));
       	parent::__construct(false, esc_html__('Themnific: Main Slider','cp-addons'),$widget_ops);  
	}
	
	function widget($args, $instance)
	{
		extract($args);
		
		$post_type = 'all';
		$categories = isset( $instance['categories'] ) ? esc_attr( $instance['categories'] ) : '';
		$posts = isset( $instance['posts'] ) ? esc_attr( $instance['posts'] ) : '';
		
		echo wp_kses_post($before_widget);
		?>
		
		<?php
		$post_types = get_post_types();
		unset($post_types['page'], $post_types['attachment'], $post_types['revision'], $post_types['nav_menu_item']);
		
		if($post_type == 'all') {
			$post_type_array = $post_types;
		} else {
			$post_type_array = $post_type;
		}
		?>
            
			<?php
			if($categories === 'all'){
							$recent_posts = new WP_Query(array(
				'showposts' => $posts,
				'post_type' => 'wellpress_slider',
			));
			}
			else {
				$recent_posts = new WP_Query(array(
				'showposts' => $posts,
				'post_type' => 'wellpress_slider',
				'tax_query' => array(
					array(
						'taxonomy' => 'group',
						'terms' => $categories,
						'field' => 'term_id',
					)
				),
			));
			}
			
		
			wp_enqueue_script('owl-carousel', plugin_dir_url(__DIR__).'assets/js/owl.carousel.min.js','','', true);
			wp_enqueue_script('owl-carousel-start', plugin_dir_url(__DIR__).'assets/js/owl.carousel.start.js','','', true);
			

			
			?>
            
            <div class="wellpress_eleslider_wrap">
            
                <img src="<?php echo plugin_dir_url(__DIR__).'assets/images/tail-spin.svg'; ?>" width="40" alt="">
                
                <div class="wellpress_eleslider loop owl-carousel loading">
                
					<?php while($recent_posts->have_posts()): $recent_posts->the_post();?>
        
                        <?php 
                            $wpm_content_position = get_post_meta(get_the_ID(), 'wellpress_slide_content_position', true);
                            $wellpress_slide_url = get_post_meta(get_the_ID(), 'wellpress_slide_url', true);
                        ?>
                              
                        <div class="eleinside eleinside_<?php echo esc_attr($wpm_content_position); ?>" data-dot="<?php the_title();?>">
                            
                            <?php if ( has_post_thumbnail()) { ?>
                                
                                <?php the_post_thumbnail( 'wellpress_slider', array('class' => 'tranz bg_image')); ?>
                            
                            	<div class="slider_overlay"></div>
                            
                            	<a class="slider_overlay_small" href="<?php echo (esc_url($wellpress_slide_url)); ?>"></a>
                                
                            <?php } ?>
                            
                            <div class="eleslideinside tranz ">
                            
                                <?php the_content(); ?>
                            
                            </div>
                                    
                        </div>
                        
                <?php endwhile; wp_reset_postdata(); ?>
                
			    </div> <!-- end .wellpress_eleslider -->
                
    		</div> <!-- end .wellpress_eleslider_wrap -->
            
			<div class="clearfix"></div>
		
		<?php
		echo wp_kses_post($after_widget);
	}
	
	function update($new_instance, $old_instance)
	{
		$instance = $old_instance;
		
		$instance['post_type'] = 'all';
		$instance['categories'] = $new_instance['categories'];
		$instance['posts'] = sanitize_text_field($new_instance['posts']);
		
		return $instance;
	}

	function form($instance)
	{
		$defaults = array( 'categories' => '', 'posts' => 4, );
		$instance = wp_parse_args((array) $instance, $defaults); ?>

		
		<p>
			<label for="<?php echo esc_attr($this->get_field_id('categories')); ?>"><?php esc_html_e('Filter by Category','cp-addons'); ?></label> 
			<select id="<?php echo esc_attr($this->get_field_id('categories')); ?>" name="<?php echo esc_attr($this->get_field_name('categories')); ?>" class="widefat categories">
				<option value='all' <?php if ('all' == $instance['categories']) echo 'selected="selected"'; ?>></option>
				<?php $categories = get_categories($args = array(
															'type'		=> 'wellpress_slider',
															'orderby'	=> 'name',
															'order'		=> 'ASC',
															'taxonomy'	=> 'group'
															)) ?>
				<?php foreach($categories as $category) { ?>
				<option value='<?php echo esc_attr($category->term_id); ?>' <?php if ($category->term_id == $instance['categories']) echo 'selected="selected"'; ?>><?php echo esc_attr($category->cat_name); ?></option>
				<?php } ?>
			</select>
		</p>
		
		<p>
			<label for="<?php echo esc_attr($this->get_field_id('posts')); ?>"><?php esc_html_e('Number of posts','cp-addons'); ?></label>
			<input class="widefat" style="width: 40px;" id="<?php echo esc_attr($this->get_field_id('posts')); ?>" name="<?php echo esc_attr($this->get_field_name('posts')); ?>" value="<?php echo esc_attr($instance['posts']); ?>" />
		</p>
		

	<?php }
}
?>